#!/usr/bin/perl
# 
# TODO: Bessere Aufbereitung zu HTML



$outd = "history";
$subrom = "romdb";
%games = ();
%roms = ();

$romdir = "$outd/$subrom";



mkdir $outd unless (-d $outd);
mkdir "$romdir" unless (-d $romdir);



sub writefile
{
    $rom_name = shift @_;
    $game_name = shift @_;
    $all_roms = shift @_;
    $file_name = "$romdir/$rom_name" . ".html";
    open OF, ">$file_name" or die;
    print OF "<html><head><title>$game_name</title></head><body>";
    print OF "<h1>$game_name</h1><p>";
    print OF "<p style=\"font-size:150%\">ROM names: <tt>$all_roms</tt></big></p>";
    $inp = 0;
    while ($l = shift @_)
    {
	$l =~ s/\</\&lt\;/g;
	$l =~ s/\>/\&gt\;/g;
	$l =~ s/\&/\&amp\;/g;
        if ($inp)
	{
	    if ($l =~ /^\s*$/)
	    {
		print OF "</p>";
		$inp = 0;
	    }
	    else
	    {
		print OF $l;
	    }
	}
	else
	{
	    if ($l =~ /^\s*\-\s*(.*)\s*\-\s*$/)
	    {
		print OF "<h2>$1</h2>";
	    }
	    elsif ($l =~ /^\s*[\*=]/)
	    {
		$l =~ s/^\s*\*/\&bull\;\&nbsp\;/;
		$l =~ s/^\s*\=+\&gt\;/\&rarr\;\&nbsp\;/;
		print OF "<p>$l";
	    }
	    elsif ($l !~ /^\s$/)
	    {
		print OF "<p style=\"margin-left:5em;\">$l";
		$inp = 1;
	    }
	}
    }
    print OF "</p>" if ($inp);
    if ($revision)
    {
	print OF "<p><small>Generated from history.dat $revision</small></p>";
    }
    print OF "</body></html>";
    close OF;
}



# Beschreibungen der Spiele erzeugen...
#
# Diese Code ist etwas schwer zu verstehen. Die Datei wird Zeile
# fuer Zeile durchgeparst, aber was mit der Zeile geschieht, ist
# abhaengig vom Status des Prozesses, der $st heisst:
#
# $st=0 Warten auf die naechste Info und die ROM-Namen
# $st=1 Warten auf die geschichtlichen Daten
# $st=2 Warten auf den Spielnamen
# $st=3 Warten auf das Ende der Daten
$st = 0;
while ($line = <>)
{
    chomp $line;
    if (!$revision && $line =~ /revision:\s(.*)$/i)
    {
	$revision = $1;
    }
    next if $line =~ /^\#/;
    $line =~ s/^\s*(.*)\s^/$1/;
    if ($st eq 0)
    {
	if ($line =~ /^.info\=(.+)/)
	{
	    $tmp = $1;
	    $tmp =~ s/\,\s*$//;
	    @roms = split /\,/, $tmp;
	    $firstrom = $roms[0];
	    foreach $romname (@roms)
	    {
		next unless $romname =~ /[a-z0-9]+/i;
		$romname and $roms{$romname} = $firstrom;
	    }
	    $st = 1;
	    @text = ();
	}
    }
    elsif ($st eq 1)
    {
	if ($line =~ /^\$bio/i)
	{
	    $st = 2;
	}
    }
    elsif ($st eq 2)
    {
	unless ($line =~ /^\s*$/)
	{
	    $line =~ s/\(c\) ?/\&copy\;/g;
	    $gamename = $line;
	    $games{$line} = $firstrom;
	    $st = 3
	}
    }
    elsif ($st eq 3)
    {
	if ($line =~ /^\$end/)
	{
	    writefile ($firstrom, $gamename, join (", ", @roms), @text);
	    $st = 0;
	}
	else
	{
	    push @text, $line;
	}
    }
}



# Leere HTML-Datei erzeugen...
open F, ">$outd/empty.html" or die;
print F "<html><head><title>Display Area</title></head><body></body></html>";
close F;



# HTML-Datei mit allen Spielen erzeugen...
open F, ">$outd/games.html" or die;
print F "<html><head><title>Game list</title></head><body>";
print F "<h1>Games</h1>";
print F "<p><a href=\"roms.html\">Switch to ROMs</a></p><ul>";
foreach $game (sort keys %games)
{
    $rom = $games{$game};
    $link = "$subrom/$rom" . ".html";
    $game =~ s/\&copy\;.*$//;
    print F "<li><a href=\"$link\" target=\"disp\">$game</a></li>";
}
print F "</ul>";
if ($revision)
{
    print F "<p><small>Generated from history.dat $revision</small></p>";
}
print F "</body></html>";
close F;



# HTML-Datei mit allen ROMs erzeugen
open F, ">$outd/roms.html" or die;
print F "<html><head><title>ROM list</title></head><body>";
print F "<h1>ROMs</h1>";
print F "<p><a href=\"games.html\">Switch to Games</a></p><ul>";
foreach $rom (sort keys %roms)
{
    $first = $roms{$rom};
    $link = "$subrom/$first" . ".html";
    print F "<li><a href=\"$link\" target=\"disp\">$rom</a></li>";
}
print F "</ul>";
if ($revision)
{
    print F "<p><small>Generated from history.dat $revision</small></p>";
}
print F "</body></html>";
close F;



# Frameset erzeugen
open F, ">$outd/index.html" or die;
print F "<html><head><title>Mame history.dat Browser</title></head>";
print F "<frameset cols=\"350,*\">";
print F "<frame name=\"games\" src=\"games.html\">";
print F "<frame name=\"disp\" src=\"empty.html\">";
print F "</frameset>";
print F "</html>";
close F;



# Aufatmen!
# Und jetzt wuensche ich viel Spass beim Lesen!
